//Gadget window events
System.Gadget.onDock = dockStateChanged;
//System.Gadget.onUndock = dockStateChanged;

function pageLoad() {
    //page initalization here
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.onSettingsClosed = settingsClosed;
	
	if (textDisplaySetting() =="") //If not settings was found load default ones
	  setDefaultSettings();
	  
	showWaitState();
}

function pageUnload() {
    //gadget is closing, clean up
}

function dockStateChanged() {
	if (System.Gadget.docked)
	{
		document.body.style.width = "130px";
		document.body.style.height = "130px";
		document.body.style.backgroundImage = 'url("resources/images/smallbg.png")';
	}
	else
	{
		document.body.style.width = "260px";
		document.body.style.height ="260px";
		document.body.style.backgroundImage = 'url("resources/images/largebg.png")';
	}
}

function settingsClosed(event) {
	if (event.closeAction == event.Action.commit)
	  showWaitState();
}

//Gadget LCD

//Shows the gadget wait state
function showWaitState() {
	disableClock(); //Stops any working timers
	stopScrolling();
	
	if (enableClockSetting())
	{
		enableClock();
	}
	else
	{
		startScrolling(textDisplaySetting());
	}
}

function getDisplay() {
	return document.getElementById("gadgetLCD");
}

var timer; //Timer used for to update the clock and the scrolling text
function startScrolling(text) {
	getDisplay().scrollLeft = 0;
	getDisplay().innerHTML = fixText(text);
	timer = setInterval("updateDisplay()", 30);
}

function stopScrolling() {
	clearInterval(timer);
}

//Updates the scrolling text display
function updateDisplay() {
	
	if (getDisplay().scrollLeft == getDisplay().scrollWidth - getDisplay().offsetWidth)
	  getDisplay().scrollLeft = 0; //Scrolls the text from the begining again
		  
	getDisplay().scrollLeft += 2;
}

//Returns a fixed string that will fit the LCD screen scroll effect
function fixText(text) {
	var spacingText = "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp"; //The number of spaces required to hide the starting word
	return (spacingText + text.replace(/ /gi, "&nbsp") + spacingText);
}

//Updates the clock
function updateClock() {
	var oSelectedTimeZone = System.Time.currentTimeZone;
	var sTimeInfo = System.Time.getLocalTime(oSelectedTimeZone);
	var currentTime = new Date(Date.parse(sTimeInfo));
	var timeString = twoDigits(currentTime.getHours()) + ':' + twoDigits(currentTime.getMinutes()); //The current time string
	getDisplay().innerHTML = timeString;
}

function twoDigits(number) {
	if (number < 10)
	  return ("0" + number);
	return number;
}

function enableClock() {
	updateClock();
	timer = setInterval("updateClock()", 1000);
}
function disableClock() {
	clearInterval(timer);
}

//Gadget buttons events
function mousePressRec() {
	document.getElementById("recButton").style.backgroundImage = 'url("resources/images/small/pressed/rec.png")';
	System.Shell.execute(exePathSetting(), "-record");
}

function mouseOverRec() {
	document.getElementById("recButton").style.backgroundImage = 'url("resources/images/small/hover/rec.png")';
	disableClock();
	startScrolling("Record a new script");
}

function mouseLeftRec() {
	document.getElementById("recButton").style.backgroundImage = 'url("")';
	stopScrolling();
	showWaitState();
}

function mousePressPlay() {
	document.getElementById("playButton").style.backgroundImage = 'url("resources/images/small/pressed/play.png")';
	System.Shell.execute(exePathSetting(), "-play");
}

function mouseOverPlay() {
	document.getElementById("playButton").style.backgroundImage = 'url("resources/images/small/hover/play.png")';
	disableClock();
	startScrolling("Play a script");
}

function mouseLeftPlay() {
	document.getElementById("playButton").style.backgroundImage = 'url("")';
	stopScrolling();
	showWaitState();
}

function mousePressOpen() {
	document.getElementById("openButton").style.backgroundImage = 'url("resources/images/small/pressed/open.png")';
	System.Shell.execute(exePathSetting());
}

function mouseOverOpen() {
	document.getElementById("openButton").style.backgroundImage = 'url("resources/images/small/hover/open.png")';
	disableClock();
	startScrolling("Open Mouse Recorder Pro");
}

function mouseLeftOpen() {
	document.getElementById("openButton").style.backgroundImage = 'url("")';
	stopScrolling();
	showWaitState();
}

